#
# $Id: install.rb,v 1.9 2004/02/10 12:47:22 Yuukis Exp $
#
#  usage: ruby install.rb [config | install | clean]
#
# Default configs are ruby's that started this script.

rubycmd = ''     # '/usr/local/bin/ruby'
bindir  = ''     # '/usr/local/bin'
libdir  = ''     # '/usr/local/lib/ruby/site_ruby/1.6'
datadir = ''     # '/usr/local/share'

binname = 'Ci'

appname = 'ci' # <= Don't Edit. BROKEN.  # concat libdir and datadir

#######################################################################
# fool proof
#

if File.exist?(binname)
	if File.size(binname) > 100
		puts ''
		puts "Sorry, '#{binname}' can't use binname."
		puts "Please edit install.rb and change binname."
		puts ''
		exit
	else
		File.unlink(binname)
	end
end

#######################################################################
# build
#

if ARGV[0] == 'config' or ARGV[0] == 'install'

require 'rbconfig'

rubycmd = Config::CONFIG['bindir']+'/'+Config::CONFIG['RUBY_INSTALL_NAME'] if rubycmd == ''
bindir  = Config::CONFIG['bindir'] if bindir == ''
libdir  = Config::CONFIG['sitelibdir'] if libdir == ''
libdir  = libdir.concat("/#{appname}")
datadir = Config::CONFIG['datadir'] if datadir == ''
datadir = datadir.concat("/#{appname}")
pixdir = datadir+'/pixmap'
fildir = datadir+'/filter'
cfg = "CFG::SYS.siteroot = \"#{datadir}/\"\n"
cmd = "#! #{rubycmd}\n\nrequire 'ci/Ci'\n"

puts 'install.rb was configured:'
puts ''
puts "\t" + 'executable ruby binary: ' + rubycmd
puts "\t" + 'install bin. directory: ' + bindir
puts "\t" + 'install lib. directory: ' + libdir
puts "\t" + 'install data directory: ' + datadir
puts ''

# build 'sitecfg.rb'

cfgfile = open('sitecfg.rb', 'w')
cfgfile.write cfg
cfgfile.close
puts "\t" + 'File created, \'sitecfg.rb\'.'

# build binname command

cmdfile = open(binname, 'w')
cmdfile.write cmd
cmdfile.close
puts "\tFile created, '#{binname}'."

unless $LOAD_PATH.index(File.dirname(libdir))
	puts ''
	puts "\t#######################################################################"
	puts "\t  WARNING: '#{File.dirname(libdir)}' isn't included Ruby \$LOAD_PATH !!"
	puts "\t#######################################################################"
end

if ARGV[0] != 'install'
	puts ''
	puts "\t" + 'Please type \'ruby install.rb install\'.'
	puts ''
	exit
end

end

#######################################################################
# install
#

if ARGV[0] == 'install'

require 'ftools'

puts ''
puts 'installing files:'
puts ''

#upgrade ?
upgrade = false
upgrade = true if File.exist?(bindir+'/'+binname)

#install bin
File.makedirs(bindir)
File.install(binname, bindir+'/'+binname, 0755, true)

#install lib
File.makedirs(libdir)
lib = [ \
	'Ci.rb',
	'appcfg.rb',
	'bbsboard.rb',
	'bbsinit.rb',
	'bbspost.rb',
	'bbsthread.rb',
	'gtkboard.rb',
	'gtkboards.rb',
	'gtkcfg.rb',
	'gtkext.rb',
	'gtkmisc.rb',
	'gtkrss.rb',
	'gtkpost.rb',
	'gtkthread.rb',
	'httpext.rb',
	'migemoext.rb',
	'nls.rb',
	'rss.rb',
	'session.rb',
	'stdext.rb',
	'sitecfg.rb',
	'util2ch.rb'
	]
lib.each {|file| File.install(file, libdir+'/'+file, 0644, true) }

#install data
File.makedirs(datadir)
share = ['aa.list', 'rss.cfg', 'ci.cfg.sample', 'ngwords.dat.sample', 'gtkrc.mona.sample']
share.each {|file| File.install(file, datadir+'/'+file, 0644, true) }

#install pixmap
File.makedirs(pixdir)
pix = Dir.glob('./pixmap/*')
pix.each {|file| File.install(file, pixdir+'/'+File.basename(file), 0644, true) }

#install filter
File.makedirs(fildir)
fil = Dir.glob('./filter/*')
fil.each {|file| File.install(file, fildir+'/'+File.basename(file), 0755, true) }

puts ''
puts 'all files installed:'
puts ''
if upgrade
	puts "\t"+' Thank you for upgrade and enjoy your 2ch life !! :)'
else
	puts "\t"+'C.i. - Compact Interface for 2ch.'
	puts ''
	puts "\t"+' You can customize this software, using  \'~/.ci/[ci.cfg, gtkrc, ngwords.dat]\'. '
	puts "\t"+' Moreover, GUI for a fundamental setup, is also prepared. '
	puts "\t"+' configuration samples is here: '
	puts "\t"*2+datadir+'/ci.cfg.sample'
	puts "\t"*2+datadir+'/gtkrc.mona.sample'
	puts "\t"*2+datadir+'/ngwords.dat.sample'
	puts ''
	puts "\t"+' Thank you for install and enjoy your 2ch life !! :)'
end
puts ''

exit

end

#######################################################################
# clean
#

if ARGV[0] == 'clean'

require 'ftools'

puts ''
puts "rm -rf ./#{binname}"
puts "rm -rf ./sitecfg.rb"
File.rm_f(binname)
File.rm_f('sitecfg.rb')
puts ''

exit

end

#######################################################################
# usage
#

puts 'usage: ruby install.rb [config | install | clean]'
